if [ $# -eq 0 ]
    then
	echo "Usage: ./compute_salience.sh no arguments" >&2
        exit 1    
    fi 
if [ $1 = "-h" ]
    then
	echo "Usage: ./compute_salience.sh language(en or pt) n-gram(1, 2 or 3) corpus_directory_name" >&2
        exit 1    
    fi 

if [ $# -ne 3 ]
    then
	echo "$0: arguments are wrong" >&2
        exit 1    
    fi
    wlRC="RC-"$1".wl"
    wlSP=$3".wl"

echo
echo "Patience, the script needs a few seconds to complete"
echo
./lib/catdir.pl "RC-"$1 2500 | ./lib/tok.pl | iconv -f utf-8 -t utf-8 -c | ./lib/check_words.pl > $wlRC  	 	#grep 'END_FILE' RC-pt.wl | wc -l 2500
./lib/catdir.pl $3 25 | ./lib/tok.pl | iconv -f utf-8 -t utf-8 -c | ./lib/check_words.pl > $wlSP  	 	#grep 'END_FILE' pt-1Meg.wl | wc -l 25

echo "> word lists done"

head -n -1 $wlRC | ./lib/curr-doc.pl  > reference_tok_corpus     
head -n -1 $wlSP | ./lib/curr-doc.pl  > specialize_tok_corpus   

cat reference_tok_corpus | ./lib/make_ngrams.pl $2 > "reference_"$2"_corpus" 
cat specialize_tok_corpus | ./lib/make_ngrams.pl $2 > "specialize_"$2"_corpus" 

echo "> "$2"-grams done"

grep -v _ "specialize_"$2"_corpus" | sort -d | uniq -c | awk '{print $2,$1}' > "specialize_tok_fqs_"$2
grep -v _ "reference_"$2"_corpus" | sort -d | uniq -c | awk '{print $2,$1}' > "reference_tok_fqs"_$2  
    
echo "> tok_fqs done"

grep -v _STOP_ "specialize_"$2"_corpus" | ./lib/doc_delimited_uniq.pl "CURR_DOC" - | grep -v "CURR_DOC" | sort -d | uniq -c | awk '{print $2,$1}' > "specialize_doc_fqs_"$2
grep -v _STOP_ "reference_"$2"_corpus" | ./lib/doc_delimited_uniq.pl "CURR_DOC" - | grep -v "CURR_DOC" | sort -d | uniq -c | awk '{print $2,$1}' > "reference_doc_fqs_"$2

echo "> doc_fqs done"

rm -f "reference_tok_fqs"_$2".add1"
./lib/add1_smoothing.pl -t "reference_tok_fqs"_$2 "specialize_tok_fqs_"$2
#wc "specialize_tok_fqs_"$2 "reference_tok_fqs"_$2".add1"  # should be the same

grep -v '_STOP_' "specialize_"$2"_corpus" | grep -v 'CURR_DOC' | wc -l > argument
./lib/mypaste.pl "specialize_tok_fqs_"$2 "reference_tok_fqs"_$2".add1" | awk '{print $1,$2,$4}' | ./lib/log_odds_ratio.pl  -t argument total - | sort -grk2 > "specialize_tok_odds_"$2

echo "> specialize_tok_odds done"

rm -f "reference_doc_fqs_"$2".add1"
./lib/add1_smoothing.pl "reference_doc_fqs_"$2 "specialize_doc_fqs_"$2
# wc "reference_doc_fqs_"$2".add1" "specialize_doc_fqs_"$2 
 
echo "> reference_doc_fqs.add1 done"	

grep 'CURR_DOC' "specialize_"$2"_corpus" | wc -l > argument1 	
grep 'CURR_DOC' "reference_"$2"_corpus" | wc -l > argument2							
./lib/mypaste.pl "specialize_doc_fqs_"$2 "reference_doc_fqs_"$2".add1" | awk '{print $1,$2,$4}' | ./lib/log_odds_ratio.pl  argument1 argument2 - | sort -grk2 > "specialize_doc_odds_"$2

echo "> specialize_doc_odds done"
# by log-odds average
#./lib/mypaste.pl "specialize_tok_odds_"$2 "specialize_doc_odds_"$2 | awk '{c=$2+$8;print $1,c,$3,$4,$5,$6,$9,$10,$11,$12}' | tr '.' ',' | sort -rnk2  > $1"_"$2"_"$3".model"
./lib/mypaste.pl "specialize_tok_odds_"$2 "specialize_doc_odds_"$2 | awk '{c=$2+$8;print $1,c}' | tr '.' ',' | sort -rgk2  > $1"_"$2"_"$3".model"


echo "> all done! Congratulations !"
echo
rm -f $wlRC $wlSP reference_tok_corpus specialize_tok_corpus "reference_"$2"_corpus" "specialize_"$2"_corpus" "reference_tok_fqs"_$2".add1" argument "specialize_tok_odds_"$2 
rm -f "reference_doc_fqs_"$2".add1" argument1 argument2 "specialize_doc_odds_"$2 total *.wl
mv "specialize_doc_fqs_"$2 $1"_specialize_doc_fqs_"$2"_"$3
mv "reference_doc_fqs_"$2 $1"_reference_doc_fqs_"$2"_"$3
mv "specialize_tok_fqs_"$2 $1"_specialize_tok_fqs_"$2"_"$3
mv "reference_tok_fqs"_$2 $1"_reference_tok_fqs_"$2"_"$3

echo "Newly created files:"
echo
echo $1"_"$2"_"$3".model"
echo $1"_specialize_doc_fqs_"$2"_"$3
echo $1"_reference_doc_fqs_"$2"_"$3
echo $1"_specialize_tok_fqs_"$2"_"$3
echo $1"_reference_tok_fqs_"$2"_"$3





