#!/usr/bin/perl 

# For comments, usage, etc., do:
# mi.pl -h

use Getopt::Std;

{
$usage = <<"_USAGE_";
Usage: ./mi.pl tok_fqs_1_file tok_fqs_2_file
_USAGE_
}

%opts = ();
getopts('h',\%opts);

if ($opts{h}) {
    print $usage;
    exit;
} 

if ((!($file1 = shift))||(!($file2 = shift))) {
    print $usage;
    exit;
}
open F1, $file1;
open F2, $file2;
my %unigram;
while(<F1>) {
	chomp;
	if (/\_/) {next}
	($term,$tf) = split;
	$unigram{$term} = $tf;
}
close F1;
while(<F2>) {
	chomp;
	if (/\_/) {next}
	($terms,$tf) = split;
	($t1,$t2) = split(/:/,$terms);
	my $t = $terms." ".log2(keys( %unigram )*$tf/($unigram{$t1}*$unigram{$t2}))."\n";
	$t =~ s/\./\,/g;
	print $t;
}
close F2;


sub log2 {
 my $n = shift;
 return log($n)/log(2);
}

